#include <iostream>
#include <string>
#include <algorithm>
#include <vector>

using namespace std;

string to_binary(int n)
{
    string s;

    while (n != 0)
    {
        s.push_back(char(n % 2 + '0'));
        n /= 2;
    }

    reverse(s.begin(), s.end());
    return s;
}

long long to_number(const string& s)
{
    long long n = 0;

    for (int i = 0; i < s.size(); ++i)
    {
        n = n * 2 + (s[i] - '0');
    }

    return n;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    long long n;
    cin >> n;

    vector<long long> v;

    for (int i = 1; (1LL << (i - 1)) <= n; ++i)
    {
        string s;

        for (int j = 1; j <= i; ++j)
        {
            if (j % 2 == 1)
            {
                s.push_back('1');
            }
            else
            {
                s.push_back('0');
            }
        }

        v.push_back(to_number(s));
    }

    int ans = 0;

    for (int i = v.size() - 1; i >= 0; --i)
    {
        if (n >= v[i])
        {
            n -= v[i];
            ans++;
        }
    }

    if (n == 0)
    {
        cout << ans << endl;
    }
    else
    {
        cout << -1 << endl;
    }

    return 0;
}
