#include <iostream>
#include <string>
#include <algorithm>
#include <vector>
#include <map>

using namespace std;

vector<long long> v;

string to_binary(int n)
{
    string s;

    while (n != 0)
    {
        s.push_back(char(n % 2 + '0'));
        n /= 2;
    }

    reverse(s.begin(), s.end());
    return s;
}

long long to_number(const string& s)
{
    long long n = 0;

    for (int i = 0; i < s.size(); ++i)
    {
        n = n * 2 + (s[i] - '0');
    }

    return n;
}

map<pair<int, long long>, int> dp;

int f(int pos, long long n)
{
    if (n == 0)
    {
        return 0;
    }

    if (pos == -1 && n == 0)
    {
        return 0;
    }

    if (pos == -1 && n != 0)
    {
        return 100000;
    }

    if (dp.find(make_pair(pos, n)) != dp.end())
    {
        return dp[make_pair(pos, n)];
    }

    int result = 100000;

    for (int i = pos; i >= 0; --i)
    {
        if (n >= v[i])
        {
            result = min(result, 1 + f(i - 1, n - v[i]));
        }
    }

    return dp[make_pair(pos, n)] = result;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    long long n;
    cin >> n;

    for (int i = 1; (1LL << (i - 1)) <= n; ++i)
    {
        string s;

        for (int j = 1; j <= i; ++j)
        {
            if (j % 2 == 1)
            {
                s.push_back('1');
            }
            else
            {
                s.push_back('0');
            }
        }

        v.push_back(to_number(s));
    }

    int ans = f(v.size() - 1, n);

    if (ans >= 100000)
    {
        cout << -1 << endl;
    }
    else
    {
        cout << ans << endl;
    }

    return 0;
}
