#include <iostream>
#include <set>
#include <algorithm>

using namespace std;

const int maxn = 100005;
const int inf = 1000000000;

int n, q;

int a[maxn];
int best[maxn];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> q;

    for (int i = 1; i <= n; ++i)
    {
        cin >> a[i];
    }

    multiset<int> ms;

    ms.insert(a[1]);
    best[1] = inf;

    for (int i = 2; i <= n; ++i)
    {
        auto it = ms.lower_bound(a[i]);

        int min_diff = inf;

        if (it != ms.end())
        {
            int num = *it;

            min_diff = min(min_diff, num - a[i]);
        }

        if (it != ms.begin())
        {
            it--;
            int num = *it;

            min_diff = min(min_diff, a[i] - num);
        }

        best[i] = min_diff;
        best[i] = min(best[i], best[i - 1]);

        ms.insert(a[i]);
    }

    while (q--)
    {
        int idx;
        cin >> idx;

        cout << best[idx] << ' ';
    }

    cout << endl;

    return 0;
}
