#include <iostream>

using namespace std;

const int maxn = 20;
const long long mod = 998244353;

int n, m, k;

long long pascal[maxn + 5][maxn + 5];

long long dp[maxn + 5][(1 << maxn) + 5];
bool is_calculated[maxn + 5][(1 << maxn) + 5];

int cnt_one_bits(int mask)
{
    int cnt = 0;

    for (int i = 0; i < m; ++i)
    {
        if ((mask & (1 << i)) != 0)
        {
            cnt++;
        }
    }

    return cnt;
}

long long fast_pow(long long a, long long b)
{
    if (b == 0) return 1;

    if (b % 2 == 0)
    {
        long long x = fast_pow(a, b / 2);
        return (x * x) % mod;
    }

    return (a * fast_pow(a, b - 1)) % mod;
}

long long inv_fact(int x)
{
    long long inv = 1;

    for (int i = 2; i <= x; ++i)
    {
        inv *= (1LL * i);
        inv %= mod;
    }

    return fast_pow(inv, mod - 2);
}

//numbers from 0 to m - 1

long long f(int pos, int mask)
{
    //cout << pos << " " << mask << endl;
    if (pos == 0)
    {
        return 1;
    }

    if (mask == 0 && pos != 0)
    {
        return 0;
    }

    if (is_calculated[pos][mask] == true)
    {
        return dp[pos][mask];
    }

    is_calculated[pos][mask] = true;

    long long result = 0;

    for (int bit = 0; bit < m; ++bit)
    {
        if ((mask & (1 << bit)) != 0)
        {
            //cout << "my mask = " << mask << " bit = " << bit << endl;
            //do not use
            result += f(pos, (mask ^ (1 << bit)));
            result %= mod;

            //use i times
            for (int i = 1; i <= k; ++i)
            {
                if (pos < i)
                {
                    break;
                }

                //cout << "using " << bit << " " << i << " times : " << pascal[pos][i] << endl;

                result += f(pos - i, (mask ^ (1 << bit))) * pascal[pos][i];
                result %= mod;
            }

            break;
        }
    }

    return dp[pos][mask] = result;
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m >> k;

    if (k * m < n)
    {
        cout << 0 << endl;
        return 0;
    }

    pascal[1][0] = 1;
    pascal[1][1] = 1;

    for (int i = 2; i <= 20; ++i)
    {
        pascal[i][0] = 1;

        for (int j = 1; j <= i; ++j)
        {
            pascal[i][j] = pascal[i - 1][j] + pascal[i - 1][j - 1];
            pascal[i][j] %= mod;
        }
    }

    cout << f(n, (1 << m) - 1) << endl;

    return 0;
}
